# eFlexPwm
Arduino eFlexPwm library for Teensy 4.x

<a href="https://www.nxp.com/docs/en/application-note/AN4485.pdf">
  <img src="https://raw.githubusercontent.com/epsilonrt/eFlexPwm/master/extras/images/eflexpwm_logo_small.png" alt="eFlexPwm Logo" align="right" valign="top">
</a>

[![GitHub release (latest by date including pre-releases)](https://img.shields.io/github/v/release/epsilonrt/eFlexPwm?include_prereleases)](https://github.com/epsilonrt/eFlexPwm/releases) 
[![PlatformIO Registry](https://badges.registry.platformio.org/packages/epsilonrt/library/eFlexPwm.svg)](https://registry.platformio.org/libraries/epsilonrt/eFlexPwm) 

[![Framework](https://img.shields.io/badge/Framework-Arduino-blue)](https://www.arduino.cc/)
[![Teensy4.1](https://github.com/epsilonrt/eFlexPwm/actions/workflows/build_teensy41.yml/badge.svg)](https://github.com/epsilonrt/eFlexPwm/actions/workflows/build_teensy41.yml) 

---

This library allows advanced use of NXP eFlexPWM timers. These timers are very powerful and can be used to manage power stages, motor controls, etc.

The Arduino API is easy to use, unfortunately, the analogWrite() function allows you to do very little when compared to the very advanced possibilities of the eFlexPwm timers of NXP microcontrollers such as the i.MXRT 1062 which equips the Teesny 4.1 !

Here is an example of 6 synchronized signals with deadtime generated by the eFlexPwmSimple program:

<img src="https://raw.githubusercontent.com/epsilonrt/eFlexPwm/master/extras/images/dslogic_example_simple.png" alt="DsLogic View" align="center" width="800">

But this is only a small example of the possibilities offered by the eFlexPwm timers which are also designed to generate SPWM signals (Sine Pulse Width Modulation) :

<img src="https://raw.githubusercontent.com/epsilonrt/eFlexPwm/r0.2/extras/images/rigol_single_phase_inverter_400hz.png" alt="Rigol View" align="center" width="800">

This library is based on the code of the FSL_PWM driver from the NXP SDK, it is published under the BSD 3-Clause License. **It is still in beta version.**

**Teesny 4.1 eFlexPWM pins**

The table below will allow you to identify the pins of the Teensy to use, by clicking on it, you can the Libre Office version of this table :

<a href="https://github.com/epsilonrt/eFlexPwm/raw/r0.2/extras/doc/Teensy41PwmPins.ods">
  <img src="https://raw.githubusercontent.com/epsilonrt/eFlexPwm/r0.2/extras/images/teensy41-eflexpwm-pin.png" alt="Teesny 4.1 eFlexPWM pins" align="center" width="500">
</a>


